%define debug_package %{nil}
%define _unpackaged_files_terminate_build 0
%define _missing_doc_files_terminate_build 0

Name: xen
Version: 4.1.3
Release: 25%{?dist}.6.10
Summary: Xen is a virtual machine monitor
Group: Development/Libraries
License: GPL
URL: http://xen.org/
# 
Source0: xen-4.1.3-ovs.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Patch1: xen-xend-always-release-vm-running-lock.patch
Patch2: xen-cs23366-23377.patch
Patch3: openvswitch.patch
Patch4: remove-if-fi.patch
Patch5: fix-empty-xml-for-state.patch
Patch6: msixtbl-write-for-mlx.patch
Patch7: xsa20.patch
Patch8: xsa21.patch
Patch9: xsa22.patch
Patch10: xsa23.patch
Patch11: xsa24.patch
Patch12: xsa25.patch
Patch13: xen-xm-reboot-wait.patch
Patch14: correct-rtc-hvm.patch
Patch15: xsa26.patch
Patch16: xsa27.patch
Patch17: xen-4.1-testing-cs-26056.patch
Patch18: xsa28.patch
Patch19: xsa29.patch
Patch20: xsa30.patch
Patch21: xsa31.patch
Patch22: add-vif-switch.patch
Patch23: disable-bridge-netfilter.patch
Patch24: xsa30-redux.patch
Patch25: xsa33.patch
Patch26: xsa36.patch
Patch27: xsa38.patch
Patch28: xsa44-4.1.patch
Patch29: xsa46-4.1.patch
Patch30: xsa47-4.1.patch
Patch31: xsa50-4.1.patch
Patch32: xsa45-4.1-01-vcpu-destroy-pagetables-preemptible.patch
Patch33: xsa45-4.1-02-new-guest-cr3-preemptible.patch
Patch34: xsa45-4.1-03-new-user-base-preemptible.patch
Patch35: xsa45-4.1-04-vcpu-reset-preemptible.patch
Patch36: xsa45-4.1-05-set-info-guest-preemptible.patch
Patch37: xsa45-4.1-06-unpin-preemptible.patch
Patch38: xsa45-4.1-07-mm-error-paths-preemptible.patch
Patch39: xsa49-4.1.patch
Patch40: xsa56.patch
# End Oracle Patches

BuildRequires: transfig libidn-devel zlib-devel curl-devel
BuildRequires: python-devel ghostscript tetex-latex gettext
BuildRequires: ncurses-devel libaio-devel libxml2-devel
BuildRequires: flex bison pciutils-devel
# for the docs 
BuildRequires: perl 
# so that the makefile knows to install udev rules
BuildRequires: udev 
BuildRequires: texi2html imake
# need this level for modprobe --dump-modversions
BuildRequires: module-init-tools >= 3.3-0.pre3.1.16
# for the VMX "bios" 
BuildRequires: dev86

# for 3rd party builds comment this line out and provide /usr/local/bin/iasl
BuildRequires: iasl_non_redistributable
# get the source from here: http://acpica.org/downloads/

Requires: bridge-utils
Requires: udev >= 059
Requires: ovs-utils
Requires: util-linux >= 2.13-0.45

# Not strictly a dependency, but kpartx is by far the most useful tool right
# now for accessing domU data from within a dom0 so bring it in when the user
# installs xen.
Requires: kpartx
Prereq: chkconfig
Obsoletes: xen-64
#ExclusiveArch: x86_64

%description
This package contains the Xen hypervisor and Xen tools, needed to
run virtual machines on x86 systems.

%package tools
Summary: Various tooling for the manipulation of Xen instances
Group: System Environment/Libraries
Requires(pre): /sbin/ldconfig 
Requires(post): /sbin/ldconfig

%description tools
This package contains the user utilities required for the manipulation
of Xen guest instances, associated documentation and keymaps.

%package debugger
Summary:  Xen is a virtual machine monitor
Group:    Development/Libraries
Requires: xen-tools = %{version}-%{release}

%description debugger
This package contains xen debuggers, kdb and gdbsx, that can be used to
debug hypervisor, dom0, and running 32-bit and 64-bit guests.

%package devel
Summary: Development libraries for Xen tools
Group: Development/Libraries
Requires: xen-tools = %{version}-%{release}
Requires(pre): /sbin/ldconfig
Requires(post): /sbin/ldconfig

%description devel
This package contains headers and static libraries to develop applications to
manage Xen virtual machines. 

%package pvhvm-devel
Summary: Development libraries for Xen PV-HVM drivers
Group: Development/Libraries

%description pvhvm-devel
This package contains the sources necessary to build paravirtualized drivers
for linux hvm domains.  These come from the unmodified_drivers/linux-2.6
directory in the source tree.

%prep
%setup -q -n xen-4.1.3-ovs
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0
%patch34 -p0
%patch35 -p0
%patch36 -p0
%patch37 -p0
%patch38 -p0
%patch39 -p0
%patch40 -p0

# Our auto patch generation will remove execute permissions, so chmod here.
%build
#make DESTDIR=$RPM_BUILD_ROOT kdb=y install-xen install-tools install-docs
#make DESTDIR=$RPM_BUILD_ROOT clean
make max_phys_cpus=160 DESTDIR=$RPM_BUILD_ROOT install-xen install-tools

%install
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/lib/%{name}/xend-db/vnet
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/lib/%{name}/xend-db/migrate
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/lib/xenstored
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/run/xenstored
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/doc/xen

rm -rf $RPM_BUILD_ROOT/%{_datadir}/doc/qemu
rm -rf $RPM_BUILD_ROOT/%{_sysconfdir}/hotplug

# install all of the public headers
mkdir -p $RPM_BUILD_ROOT%{_includedir}/xen/io $RPM_BUILD_ROOT%{_includedir}/xen/hvm
install -m 644 xen/include/public/io/*.h $RPM_BUILD_ROOT%{_includedir}/xen/io
install -m 644 xen/include/public/hvm/*.h $RPM_BUILD_ROOT%{_includedir}/xen/hvm
install -m 644 xen/include/public/*.h $RPM_BUILD_ROOT%{_includedir}/xen/
install -m 644 xen/include/public/COPYING $RPM_BUILD_ROOT%{_includedir}/xen/
#install -m 644 xen/kdb/README %{buildroot}%{_datadir}/doc/xen/README.kdb
#install -m 644 tools/debugger/gdbsx/README %{buildroot}%{_datadir}/doc/xen/README.gdbsx
#install -m 644 tools/perf/xmstat/README %{buildroot}%{_datadir}/doc/xen/README.xmstat

# install pvhvm headers and sources
mkdir -p $RPM_BUILD_ROOT/usr/src/xen-pvhvm-devel/%{version}-%{release}-%{_target_cpu}
cp -LpR unmodified_drivers/ $RPM_BUILD_ROOT/usr/src/xen-pvhvm-devel/%{version}-%{release}-%{_target_cpu}/

# fixing start-script dir - no longer needed
#rm -rf $RPM_BUILD_ROOT/etc/rc.d
#mkdir -p $RPM_BUILD_ROOT/etc/rc.d
#mv -f $RPM_BUILD_ROOT/etc/init.d $RPM_BUILD_ROOT/etc/rc.d/

#mv -f $RPM_BUILD_ROOT/etc/udev/xen-backend.rules $RPM_BUILD_ROOT/etc/udev/rules.d/

# remove docs
rm -fr %{buildroot}/%{_datadir}/doc/xen/

# create dirs in /var/run so that selinux contexts are right (#195952)
mkdir -p $RPM_BUILD_ROOT/var/run/xend $RPM_BUILD_ROOT/var/log/xen
mkdir -p $RPM_BUILD_ROOT/var/lib/xen/images

%post
/sbin/chkconfig --add xencommons
/sbin/chkconfig --add xend
/sbin/chkconfig --add xendomains

%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig --del xencommons
  /sbin/chkconfig --del xend
  /sbin/chkconfig --del xendomains
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/boot/*

%files tools
%doc COPYING README
%doc docs/pdf/
%doc docs/misc/
%config(noreplace) %{_sysconfdir}/%{name}/
%config(noreplace) %{_sysconfdir}/sysconfig/xencommons
%config(noreplace) %{_sysconfdir}/sysconfig/xendomains
%{_sbindir}/*
%{_bindir}/*
%{_libdir}/%{name}
%{_libdir}/fs/*/*.so
%{_libdir}/*.so.*
%{_libdir}/*.so
%{_mandir}/man?/*
/usr/share/xen/man/man1/qemu-img.1
/usr/share/xen/man/man1/qemu.1
/usr/share/xen/man/man8/qemu-nbd.8
/usr/share/xen/qemu/bamboo.dtb
%{_libdir}/python*/site-packages
/usr/lib/xen/boot/hvmloader
/usr/lib/xen/bin/qemu-dm
%{_libdir}/xen/boot/hvmloader
%{_libdir}/xen/bin/qemu-dm
/usr/share/xen/create.dtd
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}
%dir %{_datadir}/%{name}/qemu
%dir %{_localstatedir}/xen/dump
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/lib/xenstored
%dir %{_localstatedir}/run/xenstored
%dir %{_localstatedir}/run/xend
%dir %attr(0700,root,root) /var/log/xen
%{_datadir}/%{name}/qemu/keymaps/*
%{_datadir}/%{name}/qemu/*.bin
%{_datadir}/%{name}/qemu/*.x
%{_datadir}/%{name}/qemu/openbios*
%{_sysconfdir}/rc.d/init.d/*
#%{_sysconfdir}/udev/xend.rules
%{_sysconfdir}/udev/rules.d/*.rules
%{_localstatedir}/lib/%{name}/*
#/usr/share/doc/xen/README.xmstat

%files debugger
%{_sbindir}/gdbsx
#/usr/share/doc/xen/README.kdb
#/usr/share/doc/xen/README.gdbsx

%files devel
%defattr(-,root,root)
%{_includedir}/
%{_libdir}/*.a

%files pvhvm-devel
%defattr(-,root,root)
/usr/src/xen-pvhvm-devel/*

%changelog
* Mon May 13 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.10 
- libxc: limit cpu values when setting vcpu affinity
  When support for pinning more than 64 cpus was added, check for cpu
  out-of-range values was removed. This can lead to subsequent
  out-of-bounds cpumap array accesses in case the cpu number is higher
  than the actual count.
  This patch returns the check.
  This is CVE-2013-2072 / XSA-56
  Signed-off-by: Petr Matousek <pmatouse@redhat.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: Jerry Snitselaar <jerry.snitselaar@oracle.com> [bug 16794726] {CVE-2013-2072} 

* Fri Apr 26 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.9 
- VT-d: don't permit SVT_NO_VERIFY entries for known device types
  Only in cases where we don't know what to do we should leave the IRTE
  blank (suppressing all validation), but we should always log a warning
  in those cases (as being insecure).
  This is CVE-2013-1952 / XSA-49.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: "Zhang, Xiantao" <xiantao.zhang@intel.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16692255] {CVE-2013-1952} 

* Fri Apr 26 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.8 
- x86: make page table handling error paths preemptible
  ... as they may take significant amounts of time.
  This requires cloning the tweaked continuation logic from
  do_mmuext_op() to do_mmu_update().
  Note that in mod_l[34]_entry() a negative "preemptible" value gets
  passed to put_page_from_l[34]e() now, telling the callee to store the
  respective page in current->arch.old_guest_table (for a hypercall
  continuation to pick up), rather than carrying out the put right away.
  This is going to be made a little more explicit by a subsequent cleanup
  patch.
  This is part of CVE-2013-1918 / XSA-45.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16692132] {CVE-2013-1918} 

* Fri Apr 26 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.7 
- x86: make page table unpinning preemptible
  ... as it may take significant amounts of time.
  Since we can't re-invoke the operation in a second attempt, the
  continuation logic must be slightly tweaked so that we make sure
  do_mmuext_op() gets run one more time even when the preempted unpin
  operation was the last one in a batch.
  This is part of CVE-2013-1918 / XSA-45.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16692132] {CVE-2013-1918} 

* Fri Apr 26 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.6 
- Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16692132] {CVE-2013-1918} 

* Fri Apr 26 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.5 
- x86: make vcpu_reset() preemptible
  ... as dropping the old page tables may take significant amounts of
  time.
  This is part of CVE-2013-1918 / XSA-45.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16692132] {CVE-2013-1918} 

* Fri Apr 26 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.4 
- x86: make MMUEXT_NEW_USER_BASEPTR preemptible
  ... as it may take significant amounts of time.
  This is part of CVE-2013-1918 / XSA-45.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16692132] {CVE-2013-1918} 

* Fri Apr 26 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.3 
- x86: make new_guest_cr3() preemptible
  ... as it may take significant amounts of time.
  This is part of CVE-2013-1918 / XSA-45.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 16692132] {CVE-2013-1918} 

* Fri Apr 26 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.2 
- x86: make vcpu_destroy_pagetables() preemptible
  ... as it may take significant amounts of time.
  The function, being moved to mm.c as the better home for it anyway, and
  to avoid having to make a new helper function there non-static, is
  given a "preemptible" parameter temporarily (until, in a subsequent
  patch, its other caller is also being made capable of dealing with
  preemption).
  This is part of CVE-2013-1918 / XSA-45.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 16692132] {CVE-2013-1918} 

* Fri Apr 19 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6.1
- Fix rcu domain locking for transitive grants
  When acquiring a transitive grant for copy then the owning domain
  needs to be locked down as well as the granting domain. This was being
  done, but the unlocking was not. The acquire code now stores the
  struct domain * of the owning domain (rather than the domid) in the
  active entry in the granting domain. The release code then does the
  unlock on the owning domain.  Note that I believe I also fixed a bug
  where, for non-transitive grants the active entry contained a
  reference to the acquiring domain rather than the granting
  domain. From my reading of the code this would stop the release code
  for transitive grants from terminating its recursion correctly.
  Signed-off-by: Paul Durrant <paul.durrant@citrix.com>
  Also, for non-transitive grants we now avoid incorrectly recursing
  in __release_grant_for_copy.
  This is CVE-2013-1964 / XSA-50.
  Reported-by: Manuel Bouyer <bouyer@antioche.eu.org>
  Tested-by: Manuel Bouyer <bouyer@antioche.eu.org>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 16687161] {CVE-2013-1964} 

* Tue Apr 16 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.6 
- defer event channel bucket pointer store until after XSM checks
  Otherwise a dangling pointer can be left, which would cause subsequent
  memory corruption as soon as the space got re-allocated for some other
  purpose.
  This is CVE-2013-1920 / XSA-47.
  Reported-by: Wei Liu <wei.liu2@citrix.com>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Tim Deegan <tim@xen.org>
  John Haxby <john.haxby@oracle.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 16627108]  

* Tue Apr 16 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.5 
- x86: fix various issues with handling guest IRQs
  - properly revoke IRQ access in map_domain_pirq() error path
  - don't permit replacing an in use IRQ
  - don't accept inputs in the GSI range for MAP_PIRQ_TYPE_MSI
  - track IRQ access permission in host IRQ terms, not guest IRQ ones
  (and with that, also disallow Dom0 access to IRQ0)
  This is CVE-2013-1919 / XSA-46.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Stefano Stabellini <stefano.stabellini@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 16627078]  

* Tue Apr 16 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.4 
- x86: clear EFLAGS.NT in SYSENTER entry path
  ... as it causes problems if we happen to exit back via IRET: In the
  course of trying to handle the fault, the hypervisor creates a stack
  frame by hand, and uses PUSHFQ to set the respective EFLAGS field, but
  expects to be able to IRET through that stack frame to the second
  portion of the fixup code (which causes a #GP due to the stored EFLAGS
  having NT set).
  And even if this worked (e.g if we cleared NT in that path), it would
  then (through the fail safe callback) cause a #GP in the guest with the
  SYSENTER handler's first instruction as the source, which in turn would
  allow guest user mode code to crash the guest kernel.
  Inject a #GP on the fake (NULL) address of the SYSENTER instruction
  instead, just like in the case where the guest kernel didn't register
  a corresponding entry point.
  On 32-bit we also need to make sure we clear SYSENTER_CS for all CPUs
  (neither #RESET nor #INIT guarantee this).
  This is CVE-2013-1917 / XSA-44.
  Reported-by: Andrew Cooper <andrew.cooper3@citirx.com>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Tested-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16627030] {CVE-2013-1917} 

* Mon Feb 04 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.3
- oxenstored incorrect handling of certain Xenbus ring states
  Xen Security Advisory 38 (CVE-2013-0215)
  Patch xsa38.patch
  The oxenstored daemon (the ocaml version of the xenstore daemon) does
  not correctly handle unusual or malicious contents in the xenstore
  ring.  A malicious guest can exploit this to cause oxenstored to read
  past the end of the ring (and very likely crash) or to allocate large
  amounts of RAM.
  Signed-off-by Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16243250] {CVE-2013-0215}

* Mon Feb 04 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.3-25.el5.2 
- ACPI: acpi_table_parse() should return handler's error code
  Currently, the error code returned by acpi_table_parse()'s handler
  is ignored. This patch will propagate handler's return value to
  acpi_table_parse()'s caller.
  AMD,IOMMU: Clean up old entries in remapping tables when creating new
  interrupt mapping.
  When changing the affinity of an IRQ associated with a passed
  through PCI device, clear previous mapping.
  In addition, because some BIOSes may incorrectly program IVRS
  entries for IOAPIC try to check for entry's consistency. Specifically,
  if conflicting entries are found disable IOMMU if per-device
  remapping table is used. If entries refer to bogus IOAPIC IDs
  disable IOMMU unconditionally
  AMD,IOMMU: Disable IOMMU if SATA Combined mode is on
  AMD's SP5100 chipset can be placed into SATA Combined mode
  that may cause prevent dom0 from booting when IOMMU is
  enabled and per-device interrupt remapping table is used.
  While SP5100 erratum 28 requires BIOSes to disable this mode,
  some may still use it.
  This patch checks whether this mode is on and, if per-device
  table is in use, disables IOMMU.
  AMD,IOMMU: Make per-device interrupt remapping table default
  Using global interrupt remapping table may be insecure, as
  described by XSA-36. This patch makes per-device mode default.
  This is XSA-36 / CVE-2013-0153.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Signed-off-by: Boris Ostrovsky <boris.ostrovsky@amd.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 16273845] {CVE-2013-0153} 

* Wed Jan 16 2013 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-25.el5.1 
- Xen Security Advisory CVE-2012-5634 / XSA-33 (v3)
  VT-d interrupt remapping source validation flaw
  UPDATES IN VERSION 3
  ====================
  The patch supplied for Xen 4.1 (xsa33-4.1.patch) contained a build
  error. A corrected patch is attached. The fix is also now available in
  http://xenbits.xen.org/hg/xen-4.1-testing.hg as changeset
  23441:2a91623a5807
  ISSUE DESCRIPTION
  =================
  When passing a device which is behind a legacy PCI Bridge through to
  a guest Xen incorrectly configures the VT-d hardware. This could allow
  incorrect interrupts to be injected to other guests which also have
  passthrough devices.
  In a typical Xen system many devices are owned by domain 0 or driver
  domains, leaving them vulnerable to such an attack. Such a DoS is
  likely to have an impact on other guests running in the system.
  IMPACT
  ======
  A malicious domain, given access to a device which is behind a legacy
  PCI bridge, can mount a denial of service attack affecting the whole
  system.
  VULNERABLE SYSTEMS
  ==================
  Xen version 4.0 onwards is vulnerable.
  Only systems using Intel VT-d for PCI passthrough are vulnerable.
  Any domain which is given access to a PCI device that is behind a
  legacy PCI bridge can take advantage of this vulnerability.
  Domains which are given access to PCIe devices only are not able to
  take advantage of this vulnerability.
  MITIGATION
  ==========
  This issue can be avoided by not assigning PCI devices which are
  behind a legacy PCI bridge to untrusted guests.
  Patch:
  VT-d: fix interrupt remapping source validation for devices behind
  legacy bridges
  Using SVT_VERIFY_BUS here doesn't make sense; native Linux also
  uses SVT_VERIFY_SID_SQ here instead.
  This is XSA-33 / CVE-2012-5634.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 16023718]  

* Wed Dec 05 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-25 
- Xen Security Advisory CVE-2012-5514 / XSA-30 (v4).
  aka. Broken error handling in guest_physmap_mark_populate_on_demand()
  The original checkin was using v1, which did not have the
  extra check for priviliged domains and the less verbose printk.
  This patch updates the xsa-30 to v4.
  ISSUE DESCRIPTION
  =================
  guest_physmap_mark_populate_on_demand(), before carrying out its actual
  operation, checks that the subject GFNs are not in use. If that check fails,
  the code prints a message and bypasses the gfn_unlock() matching the
  gfn_lock() carried out before entering the loop.
  Further, the function is exposed to the use of guests on their own
  behalf.  While we believe that this does not cause any further issues,
  we have not conducted a thorough enough review to be sure.  Rather, it
  should be exposed only to privileged domains.
  IMPACT
  ======
  A malicious guest administrator can cause Xen to hang.
  Patch:
  xen: fix error handling of guest_physmap_mark_populate_on_demand()
  The only user of the "out" label bypasses a necessary unlock, thus
  enabling the caller to lock up Xen.
  Also, the function was never meant to be called by a guest for itself,
  so rather than inspecting the code paths in depth for potential other
  problems this might cause, and adjusting e.g. the non-guest printk()
  in the above error path, just disallow the guest access to it.
  Finally, the printk() (considering its potential of spamming the log,
  the more that it's not using XENLOG_GUEST), is being converted to
  P2M_DEBUG(), as debugging is what it apparently was added for in the
  first place.
  This is XSA-30 / CVE-2012-5514.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: George Dunlap <george.dunlap@eu.citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 15953919]  

* Tue Nov 20 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.3-24 
- Disable netfilter on bridges. [bug 15871028]  

* Fri Nov 16 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.3-23 
- Add vif-switch to the make file so that it is put in the xen scripts directory. [bug 15886237]  

* Fri Nov 16 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-22 
- Xen Security Advisory CVE-2012-5515 / XSA-31
  Several memory hypercall operations allow invalid extent order values
  *** EMBARGOED UNTIL Thursday 2012-11-29 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  Allowing arbitrary extent_order input values for XENMEM_decrease_reservation,
  XENMEM_populate_physmap, and XENMEM_exchange can cause arbitrarily long time
  being spent in loops without allowing vital other code to get a chance to
  execute. This may also cause inconsistent state resulting at the completion
  of these hypercalls.
  IMPACT
  ======
  A malicious guest administrator can cause Xen to hang.
  VULNERABLE SYSTEMS
  ==================
  All Xen versions are vulnerable.  However, older versions (not supporting
  Populate-on-Demand, i.e. before 3.4) may only be theoretically affected.
  MITIGATION
  ==========
  Running only trusted guest kernels will avoid this vulnerability.
  Patch:
  memop: limit guest specified extent order
  Allowing unbounded order values here causes almost unbounded loops
  and/or partially incomplete requests, particularly in PoD code.
  The added range checks in populate_physmap(), decrease_reservation(),
  and the "in" one in memory_exchange() architecturally all could use
  PADDR_BITS - PAGE_SHIFT, and are being artificially constrained to
  MAX_ORDER.
  This is XSA-31 / CVE-2012-5515.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Nov 16 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-21 
- Xen Security Advisory CVE-2012-5514 / XSA-30
  Missing unlock in guest_physmap_mark_populate_on_demand()
  *** EMBARGOED UNTIL Thursday 2012-11-29 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  guest_physmap_mark_populate_on_demand(), before carrying out its actual
  operation, checks that the subject GFNs are not in use. If that check fails,
  the code bypasses the gfn_unlock() matching the gfn_lock() carried out
  before entering the loop.
  IMPACT
  ======
  A malicious supervising domain (e.g. stubdom) can cause Xen to hang.
  VULNERABLE SYSTEMS
  ==================
  All Xen version from 3.4 on are vulnerable.
  The vulnerability is only exposed by HVM guests.
  MITIGATION
  ==========
  Running only PV guests, or ensuring that HVM guest supervision is done only
  by trusted code, will avoid this vulnerability.
  xen: fix error path of guest_physmap_mark_populate_on_demand()
  The only user of the "out" label bypasses a necessary unlock, thus
  enabling the caller to lock up Xen.
  This is XSA-30 / CVE-2012-5514.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Nov 16 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-20 
- Xen Security Advisory CVE-2012-5513 / XSA-29
  XENMEM_exchange may overwrite hypervisor memory
  *** EMBARGOED UNTIL Thursday 2012-11-29 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  The handler for XENMEM_exchange accesses guest memory without range checking
  the guest provided addresses, thus allowing these accesses to include the
  hypervisor reserved range.
  IMPACT
  ======
  A malicious guest administrator can cause Xen to crash.  If the out of address
  space bounds access does not lead to a crash, a carefully crafted privilege
  escalation cannot be excluded, even though the guest doesn't itself control
  the values written.
  VULNERABLE SYSTEMS
  ==================
  All Xen versions are vulnerable.
  The vulnerability is only exposed to PV guests.
  MITIGATION
  ==========
  Running only HVM guests, or ensuring that PV guests only use trusted kernels,
  will avoid this vulnerability.
  Patch:
  xen: add missing guest address range checks to XENMEM_exchange handlers
  Ever since its existence (3.0.3 iirc) the handler for this has been
  using non address range checking guest memory accessors (i.e.
  the ones prefixed with two underscores) without first range
  checking the accessed space (via guest_handle_okay()), allowing
  a guest to access and overwrite hypervisor memory.
  This is XSA-29 / CVE-2012-5513.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Nov 16 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-19 
- Xen Security Advisory CVE-2012-5512 / XSA-28
  HVMOP_get_mem_access crash / HVMOP_set_mem_access information leak
  *** EMBARGOED UNTIL Thursday 2012-11-29 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  The HVMOP_set_mem_access operation handler uses an input as an array index
  before range checking it.
  IMPACT
  ======
  A malicious guest administrator can cause Xen to crash.  If the out of array
  bounds access does not crash, the arbitrary value read will be used if the
  caller reads back the default access through the HVMOP_get_mem_access
  operation, thus causing an information leak. The caller cannot, however,
  directly control the address from which to read, since the value read in the
  first step will be used as an array index again in the second step.
  VULNERABLE SYSTEMS
  ==================
  Only Xen version 4.1 is vulnerable.
  The vulnerability is only exposed to HVM guests.
  MITIGATION
  ==========
  Running only PV guests, or ensuring that the controlling domain of HVM
  guests (e.g. dom0 or stubdom) only uses trusted code, will avoid this
  vulnerability.
  Patch:
  x86/HVM: range check xen_hvm_set_mem_access.hvmmem_access before use
  Otherwise an out of bounds array access can happen if changing the
  default access is being requested, which - if it doesn't crash Xen -
  would subsequently allow reading arbitrary memory through
  HVMOP_get_mem_access (again, unless that operation crashes Xen).
  This is XSA-28 / CVE-2012-5512.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Nov 16 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.3-18 
- More efficient TLB-flush filtering in alloc_heap_pages().
  Rather than per-cpu filtering for every page in a super-page
  allocation, simply remember the most recent TLB timestamp across all
  allocated pages, and filter on that, just once, at the end of the
  function.
  For large-CPU systems, doing 2MB allocations during domain creation,
  this cuts down the domain creation time *massively*.
  TODO: It may make sense to move the filtering out into some callers,
  such as memory.c:populate_physmap() and
  memory.c:increase_reservation(), so that the filtering can be moved
  outside their loops, too.
  Signed-off-by: Keir Fraser <keir@xen.org>
  xen-unstable changeset: 26056:177fdda0be56
  xen-unstable date: Mon Oct 15 15:38:11 UTC 2012 [bug 15885849]  

* Fri Nov 16 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-17 
- Xen Security Advisory CVE-2012-5511 / XSA-27
  several HVM operations do not validate the range of their inputs
  *** EMBARGOED UNTIL Thursday 2012-11-29 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  Several HVM control operations do not check the size of their inputs
  and can tie up a physical CPU for extended periods of time.
  In addition dirty video RAM tracking involves clearing the bitmap
  provided by the domain controlling the guest (e.g. dom0 or a
  stubdom). If the size of that bitmap is overly large, an intermediate
  variable on the hypervisor stack may overflow that stack.
  IMPACT
  ======
  A malicious guest administrator can cause Xen to become unresponsive
  or to crash leading in either case to a Denial of Service.
  VULNERABLE SYSTEMS
  ==================
  All Xen versions from 3.4 onwards are vulnerable.
  However Xen 4.2 and unstable are not vulnerable to the stack
  overflow. Systems running either of these are not vulnerable to the
  crash.
  Version 3.4, 4.0 and 4.1 are vulnerable to both the stack overflow and
  the physical CPU hang.
  The vulnerability is only exposed to HVM guests.
  MITIGATION
  ==========
  Running only PV guests will avoid this vulnerability.
  Patch:
  hvm: Limit the size of large HVM op batches
  Doing large p2m updates for HVMOP_track_dirty_vram without preemption
  ties up the physical processor. Integrating preemption into the p2m
  updates is hard so simply limit to 1GB which is sufficient for a 15000
  * 15000 * 32bpp framebuffer.
  For HVMOP_modified_memory and HVMOP_set_mem_type preemptible add the
  necessary machinery to handle preemption.
  This is CVE-2012-5511 / XSA-27.
  Signed-off-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  x86/paging: Don't allocate user-controlled amounts of stack memory.
  This is XSA-27 / CVE-2012-5511.
  Signed-off-by: Tim Deegan <tim@xen.org>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Nov 16 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-16 
- Xen Security Advisory CVE-2012-5510 / XSA-26
  Grant table version switch list corruption vulnerability
  *** EMBARGOED UNTIL Thursday 2012-11-29 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  Downgrading the grant table version of a guest involves freeing its
  status pages. This freeing was incomplete - the page(s) are freed back
  to the allocator, but not removed from the domain's tracking
  list. This would cause list corruption, eventually leading to a
  hypervisor crash.
  IMPACT
  ======
  A malicious guest administrator can cause Xen to crash, leading to a
  denial of service attack.
  VULNERABLE SYSTEMS
  ==================
  All Xen version from 4.0 on are vulnerable.
  Version 3.4 and earlier are not vulnerable.
  Patch contents:
  gnttab: fix releasing of memory upon switches between versions
  gnttab_unpopulate_status_frames() incompletely freed the pages
  previously used as status frame in that they did not get removed from
  the domain's xenpage_list, thus causing subsequent list corruption
  when those pages did get allocated again for the same or another purpose.
  Similarly, grant_table_create() and gnttab_grow_table() both improperly
  clean up in the event of an error - pages already shared with the guest
  can't be freed by just passing them to free_xenheap_page(). Fix this by
  sharing the pages only after all allocations succeeded.
  This is CVE-2012-5510 / XSA-26.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Wed Nov 07 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.3-15 
- Correct RTC time offset update error for HVM guest
  changeset 24947:b198ada9689d [bug 14676537]  

* Wed Oct 31 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.3-14 
- fix xm reboot wait exception
  For VM reboot, the VM will first shutdown and then xend will recreate it. This
  bug is caused by: when we do server.xend.domains(), the VM is live; when we do
  server.xend.domain.getRestartCount(), the VM is dead, thus raise an exception.
  We can ignore this exception and just continue: this domain will be handled in
  the next loop (it will not in the live vm list).
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Jingjie Jiang <jingjie.jiang@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  oracle-Bug: 14836200 

* Fri Oct 26 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-13 
- Xen Security Advisory CVE-2012-4544 / XSA-25
  Xen domain builder Out-of-memory due to malicious kernel/ramdisk
  ISSUE DESCRIPTION
  =================
  The Xen PV domain builder contained no validation of the size of the
  supplied kernel or ramdisk either before or after decompression. This
  could cause the toolstack to consume all available RAM in the domain
  running the domain builder.
  IMPACT
  ======
  A malicious guest administrator who can supply a kernel or ramdisk can
  exhaust memory in domain 0 leading to a denial of service attack.
  VULNERABLE SYSTEMS
  ==================
  All versions of Xen are vulnerable.
  MITIGATION
  ==========
  Running only trusted kernels and ramdisks will avoid this
  vulnerability.
  Using pvgrub also avoids this vulnerability since the builder will run
  in guest context. (nb: use of pygrub *is* vulnerable).
  Running only HVM guests will avoid this vulnerability.
  RELATED ISSUE
  =============
  CVE-2012-2625 covers a bug in pygrub which caused that process to
  consume excessive amount of memory under similar circumstances to the
  above.
  This was fixed in xen-unstable (and the fix inherited by Xen 4.2.x) in
  revision 25589:60f09d1ab1fe but not called out as a security problem.
  This fix is also included, where relevant, in the patches below.
  RESOLUTION
  ==========
  Applying the appropriate attached patch resolves this issue, including
  the related pygrub fix where neccesary.
  xsa25-unstable.patch        Xen unstable
  xsa25-4.2.patch             Xen 4.2.x
  xsa25-4.1.patch             Xen 4.1.x
  $ sha256sum xsa25*.patch
  613e4b82cdc9cabf9cbd52076118887b298c47e680c2066a28a77f12e9f90606  xsa25-4.1.patch
  135bc089d003f9b97991764c37b1ab8d37e9cbcfa1b9bd7429b4503abe00c8f5  xsa25-4.2.patch
  534495b7eef6e599f5814f0a67fc84fbe2e8eee9d223a09ad178ff63bdcda3dd  xsa25-unstable.patch
  Note that these patches impose a new size limit of 1Gby on both the
  compressed and uncompressed sizes of ramdisks.  On some systems it may
  be desirable to relax these limits and risk virtual address or memory
  exhaustion in the toolstack.  This can be achieved by setting
  XC_DOM_DECOMPRESS_MAX to the desired limit (in bytes). This can be
  done by building with "APPEND_CFLAGS=-DXC_DOM_DECOMPRESS_MAX=<limit>"
  or by editing tools/libxc/xc_dom.h directly.
  NOTE REGARDING LACK OF EMBARGO
  ==============================
  These issues have already been discussed in public in various places,
  including https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2012-2625
  and http://bugs.debian.org/688125.  This advisory is therefore not
  subject to an embargo.
  Patch contains:
  libxc: builder: limit maximum size of kernel/ramdisk.
  Allowing user supplied kernels of arbitrary sizes, especially during
  decompression, can swallow up dom0 memory leading to either virtual
  address space exhaustion in the builder process or allocation
  failures/OOM killing of both toolstack and unrelated processes.
  We disable these checks when building in a stub domain for pvgrub
  since this uses the guest's own memory and is isolated.
  Decompression of gzip compressed kernels and ramdisks has been safe
  since 14954:58205257517d (Xen 3.1.0 onwards).
  This is XSA-25 / CVE-2012-4544.
  Also make explicit checks for buffer overflows in various
  decompression routines. These were already ruled out due to other
  properties of the code but check them as a belt-and-braces measure.
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  [ Includes 25589:60f09d1ab1fe for CVE-2012-2625 ]
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Oct 26 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-12 
- Xen Security Advisory CVE-2012-4538 / XSA-23
  Unhooking empty PAE entries DoS vulnerability
  *** EMBARGOED UNTIL Tuesday 2012-11-13 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  The HVMOP_pagetable_dying hypercall does not correctly check the
  caller's pagetable state, leading to a hypervisor crash.
  IMPACT
  ======
  An HVM guest running on shadow pagetables (that is, not HAP) can
  cause the hypervisor to crash.
  VULNERABLE SYSTEMS
  ==================
  All Xen versions from 4.0 onwards are vulnerable, except that:
  - systems that run only PV guests are not vulnerable
  - systems that run all HVM guests using HAP (which is the default on
  hardware that supports it) are not vulnerable.
  MITIGATION
  ==========
  This issue can be avoided by running only PV guests or by running
  all HVM guests using hardware-assisited paging (HAP, also called
  NPT, RVI and EPT).
  Xen will run guests using HAP by default on hardware that
  supports it, unless it is disbled by putting 'hap=0' either on
  the xen hypervisor command-line or in the VM's configuration.
  You can check whether a particular machine supports HAP by looking at
  xen's boot messages.  On Xen 4.1, 4.2 and unstable, Xen will print
  "HVM: Hardware Assisted Paging (HAP) detected" during boot; on xen 4.0
  the message is "HVM: Hardware Assisted Paging detected".
  Patch contains:
  xen/mm/shadow: check toplevel pagetables are present before unhooking them.
  If the guest has not fully populated its top-level PAE entries when it calls
  HVMOP_pagetable_dying, the shadow code could try to unhook entries from
  MFN 0.  Add a check to avoid that case.
  This issue was introduced by c/s 21239:b9d2db109cf5.
  This is a security problem, XSA-23 / CVE-2012-4538.
  Signed-off-by: Tim Deegan <tim@xen.org>
  Tested-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Oct 26 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-11 
- Xen Security Advisory CVE-2012-4538 / XSA-23
  Unhooking empty PAE entries DoS vulnerability
  *** EMBARGOED UNTIL Tuesday 2012-11-13 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  The HVMOP_pagetable_dying hypercall does not correctly check the
  caller's pagetable state, leading to a hypervisor crash.
  IMPACT
  ======
  An HVM guest running on shadow pagetables (that is, not HAP) can
  cause the hypervisor to crash.
  VULNERABLE SYSTEMS
  ==================
  All Xen versions from 4.0 onwards are vulnerable, except that:
  - systems that run only PV guests are not vulnerable
  - systems that run all HVM guests using HAP (which is the default on
  hardware that supports it) are not vulnerable.
  MITIGATION
  ==========
  This issue can be avoided by running only PV guests or by running
  all HVM guests using hardware-assisited paging (HAP, also called
  NPT, RVI and EPT).
  Xen will run guests using HAP by default on hardware that
  supports it, unless it is disbled by putting 'hap=0' either on
  the xen hypervisor command-line or in the VM's configuration.
  You can check whether a particular machine supports HAP by looking at
  xen's boot messages.  On Xen 4.1, 4.2 and unstable, Xen will print
  "HVM: Hardware Assisted Paging (HAP) detected" during boot; on xen 4.0
  the message is "HVM: Hardware Assisted Paging detected".
  Patch contains:
  xen/mm/shadow: check toplevel pagetables are present before unhooking them.
  If the guest has not fully populated its top-level PAE entries when it calls
  HVMOP_pagetable_dying, the shadow code could try to unhook entries from
  MFN 0.  Add a check to avoid that case.
  This issue was introduced by c/s 21239:b9d2db109cf5.
  This is a security problem, XSA-23 / CVE-2012-4538.
  Signed-off-by: Tim Deegan <tim@xen.org>
  Tested-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Oct 26 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-10 
- Xen Security Advisory CVE-2012-4537 / XSA-22
  version 3
  Memory mapping failure DoS vulnerability
  *** EMBARGOED UNTIL Tuesday 2012-11-13 12:00:00 UTC ***
  UPDATES IN VERSION 3
  ====================
  Correct patch names in description. The actual supplied patches were correct.
  ISSUE DESCRIPTION
  =================
  When set_p2m_entry fails, Xen's internal data structures (the p2m and
  m2p tables) can get out of sync.  This failure can be triggered by
  unusual guest behaviour exhausting the memory reserved for the p2m
  table.  If it happens, subsequent guest-invoked memory operations can
  cause Xen to fail an assertion and crash.
  IMPACT
  ======
  A malicious guest administrator might be able to cause Xen to crash.
  VULNERABLE SYSTEMS
  ==================
  All versions of Xen since at least 3.4 are vulnerable.
  The vulnerability is only exposed to HVM guests.
  Patch contains:
  x86/physmap: Prevent incorrect updates of m2p mappings
  In certain conditions, such as low memory, set_p2m_entry() can fail.
  Currently, the p2m and m2p tables will get out of sync because we still
  update the m2p table after the p2m update has failed.
  If that happens, subsequent guest-invoked memory operations can cause
  BUG()s and ASSERT()s to kill Xen.
  This is fixed by only updating the m2p table iff the p2m was
  successfully updated.
  This is a security problem, XSA-22 / CVE-2012-4537.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Oct 26 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-9 
- Xen Security Advisory CVE-2012-4536 / XSA-21
  pirq range check DoS vulnerability
  *** EMBARGOED UNTIL Tuesday 2012-11-13 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  domain_pirq_to_emuirq() uses the guest provided pirq value before
  range checking it, and physdev_unmap_pirq uses domain_pirq_to_emuirq
  without checking the pirq value either.  Invalid pirq values can cause
  Xen to read out of array bounds, usually resulting in a fatal page
  fault.
  IMPACT
  ======
  A malicious guest administrator can cause Xen to crash.  If the out of
  array bounds access does not crash, the arbitrary value read will be
  ignored due to later error checking, so there is no privilege
  escalation and no exploitable information leak.
  VULNERABLE SYSTEMS
  ==================
  Only Xen version 4.1 is vulnerable.  Other released versions, and
  xen-unstable, are not vulnerable.
  The vulnerability is only exposed to HVM guests.
  MITIGATION
  ==========
  Running only PV guests, or ensuring that HVM guests only use trusted
  kernels, will avoid this vulnerability.
  Patch contents:
  x86/physdev: Range check pirq parameter from guests
  Otherwise Xen will read beyond either end of the struct
  domain.arch.pirq_emuirq array, usually resulting in a fatal page fault.
  This vulnerability was introduced by c/s 23241:d21100f1d00e, which adds
  a call to domain_pirq_to_emuirq() which uses the guest provided pirq
  value before range checking it, and was fixed by c/s 23573:584c2e5e03d9
  which changed the behaviour of the domain_pirq_to_emuirq() macro to use
  radix trees instead of a flat array.
  This is XSA-21 / CVE-2012-4536.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Oct 26 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-8 
- Xen Security Advisory CVE-2012-4535 / XSA-20
  Timer overflow DoS vulnerability
  *** EMBARGOED UNTIL Tuesday 2012-11-13 12:00:00 UTC ***
  ISSUE DESCRIPTION
  =================
  A guest which sets a VCPU with an inappropriate deadline can cause an
  infinite loop in Xen, blocking the affected physical CPU
  indefinitely.
  IMPACT
  ======
  A malicious guest administrator can trigger the bug.  If the Xen
  watchdog is enabled, the whole system will crash.  Otherwise the guest
  can cause the system to become completely unresponsive.
  VULNERABLE SYSTEMS
  ==================
  All versions of Xen from at least 3.4 onwards are vulnerable, to every
  kind of guest.
  Systems with only trusted guest kernels are not vulnerable.
  MITIGATION
  ==========
  There is no mitigation available other than to use a trusted guest
  kernel.
  Patch writeup:
  VCPU/timers: Prevent overflow in calculations, leading to DoS vulnerability
  The timer action for a vcpu periodic timer is to calculate the next
  expiry time, and to reinsert itself into the timer queue.  If the
  deadline ends up in the past, Xen never leaves __do_softirq().  The
  affected PCPU will stay in an infinite loop until Xen is killed by the
  watchdog (if enabled).
  This is a security problem, XSA-20 / CVE-2012-4535.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Oct 19 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.3-7 
- patch from chien.yen@oracle.com to fix XEN msixtbl_write() so that MLX driver can be
  loaded, unloaded  successfull [bug 14787687]  

* Thu Oct 18 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.3-6 
- fix empty xml for state
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Chuang Cao <chuang.cao@oracle.com> [bug 14776605]  

* Thu Oct 11 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.3-5 
- Comment out if,fi. 

* Wed Oct 10 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.3-4 
- Added support for openvswitch
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> 

* Tue Oct 02 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.3-3 
- tmem: Back-port xen cs/23266 up to cs/23377 tmem related fixes.
  [in the Xen-unstable tree they are: 23850->25860 and 25929]
  This is a combination of all those changesets together. The
  patch descriptions are as follow:
  tmem: only allow tmem control operations from privileged domains
  This is part of XSA-15 / CVE-2012-3497.
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  xen-unstable changeset: 25850:0dba5a888655
  xen-unstable date: Tue Sep 11 12:06:30 UTC 2012
  tmem: consistently make pool_id a uint32_t
  Treating it as an int could allow a malicious guest to provide a
  negative pool_Id, by passing the MAX_POOLS_PER_DOMAIN limit check and
  allowing access to the negative offsets of the pool array.
  This is part of XSA-15 / CVE-2012-3497.
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  xen-unstable changeset: 25851:fcf567acc92a
  xen-unstable date: Tue Sep 11 12:06:43 UTC 2012
  tmem: check the pool_id is valid when destroying a tmem pool
  This is part of XSA-15 / CVE-2012-3497.
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  xen-unstable changeset: 25852:d189d99ef00c
  xen-unstable date: Tue Sep 11 12:06:54 UTC 2012
  tmem: check for a valid client ("domain") in the save subops
  This is part of XSA-15 / CVE-2012-3497.
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  xen-unstable changeset: 25853:f53c5aadbba9
  xen-unstable date: Tue Sep 11 12:17:27 UTC 2012
  tmem: don't access guest memory without using the accessors intended for this
  This is not permitted, not even for buffers coming from Dom0 (and it
  would also break the moment Dom0 runs in HVM mode). An implication from
  the changes here is that tmh_copy_page() can't be used anymore for
  control operations calling tmh_copy_{from,to}_client() (as those pass
  the buffer by virtual address rather than MFN).
  Note that tmemc_save_get_next_page() previously didn't set the returned
  handle's pool_id field, while the new code does. It need to be
  confirmed that this is not a problem (otherwise the copy-out operation
  will require further tmh_...() abstractions to be added).
  Further note that the patch removes (rather than adjusts) an invalid
  call to unmap_domain_page() (no matching map_domain_page()) from
  tmh_compress_from_client() and adds a missing one to an error return
  path in tmh_copy_from_client().
  Finally note that the patch adds a previously missing return statement
  to cli_get_page() (without which that function could de-reference a
  NULL pointer, triggerable from guest mode).
  This is part of XSA-15 / CVE-2012-3497.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  xen-unstable changeset: 25854:ccd60ed6c555
  xen-unstable date: Tue Sep 11 12:17:49 UTC 2012
  tmem: detect arithmetic overflow in tmh_copy_{from,to}_client()
  This implies adjusting callers to deal with errors other than -EFAULT
  and removing some comments which would otherwise become stale.
  Reported-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  xen-unstable changeset: 25855:33b8c42a87ec
  xen-unstable date: Tue Sep 11 12:17:59 UTC 2012
  tmem: properly drop lock on error path in do_tmem_get()
  Also remove a bogus assertion.
  Reported-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  xen-unstable changeset: 25856:83b97a59888b
  xen-unstable date: Tue Sep 11 12:18:08 UTC 2012
  tmem: properly drop lock on error path in do_tmem_op()
  Reported-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  xen-unstable changeset: 25857:109ea6a0c23a
  xen-unstable date: Tue Sep 11 12:18:26 UTC 2012
  tmem: reduce severity of log messages
  Otherwise they can be used by a guest to spam the hypervisor log with
  all settings at their defaults.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Zhenzhong Duan <zhenzhong.duan@oracle.com>
  xen-unstable changeset: 25858:0520982a602a
  xen-unstable date: Tue Sep 11 12:18:36 UTC 2012
  tmem: fixup 2010 cleanup patch that breaks tmem save/restore
  20918:a3fa6d444b25 "Fix domain reference leaks" (in Feb 2010, by Jan)
  does some cleanup in addition to the leak fixes.  Unfortunately, that
  cleanup inadvertently resulted in an incorrect fallthrough in a switch
  statement which breaks tmem save/restore.
  That broken patch was apparently applied to 4.0-testing and 4.1-testing
  so those are broken as well.
  What is the process now for requesting back-patches to 4.0 and 4.1?
  (Side note: This does not by itself entirely fix save/restore in 4.2.)
  Signed-off-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  xen-unstable changeset: 25859:16e0392c6594
  xen-unstable date: Tue Sep 11 12:19:03 UTC 2012
  tmem: cleanup
  - one more case of checking for a specific rather than any error
  - drop redundant casts
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  xen-unstable changeset: 25860:e4cb84111610
  xen-unstable date: Tue Sep 11 12:19:29 UTC 2012
  tmem: bump pool version to 1 to fix restore issue when tmem enabled
  Restore fails when tmem is enabled both in hypervisor and guest. This
  is due to spec version mismatch when restoring a pool.
  Signed-off-by: Zhenzhong Duan <zhenzhong.duan@oracle.com>
  Acked-by: Dan Magenheimer <dan.magenheimer@oracle.com>
  xen-unstable changeset: 25929:fee83ac77d8c
  xen-unstable date: Wed Sep 19 15:38:47 UTC 2012
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Thu Sep 27 2012 Srinivas Maturi <srinivas.maturi@oracle.com> - 4.1.3-2
- rebase tarball

* Wed Sep 26 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-53
- always release vm running lock on VM shutdown
  Before this patch, when xend restarted, the VM running lock will not be released
  on shutdown, so the VM could never start again.
  Talked with Junjie, we recommend always releasing the lock on VM shutdown. So
  even when xend restarted, there should be no stale lock leaving there.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 14663406]  

* Wed Sep 26 2012 Junjie Wei <junjie.wei@oracle.com> - 4.1.2-52
- Update Xen and QEMU from 4.1.2 to 4.1.3.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com> 

* Fri Sep 14 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-51 
- hvmload: Revert bison files that were accidently checked in.
  The "hvmloader: Only clear relevant parts, not the whole page"
  accidently checked in the bison generated files. This
  removes it.
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Sep 14 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-50 
- hvmloader: Only clear relevant parts, not the whole page.
  The hvmloader interacts with the XenBus and when its done it
  calls tools/firmware/hvmloader/xenbus.c:xenbus_shutdown()
  which zero's the entire shared_info page.
  It doesn't affect 64-bit guest because Xen has to rewrite the
  wc fields on transition from 32 to 64 (mm/hvm.c:hvm_latch_shinfo_size)
  while on 32-bit it detects no transition (so does nothing).
  This patch resets relevant parts of the shared_info page.
  [Note: This patch is not yet upstream, but Keir is going
  to post it for Xen 4.2.1).
  Signed-off-by: Keir Fraser <keir@xen.org>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 14519356]  

* Tue Sep 11 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-49 
- Disable iptables when adding a VIF to a Bridge [bug 14611657]  

* Mon Sep 10 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-48 
- xend bootloader: read pending data when bootloader exits
  When dom0 under heavy pressure, the pipe read in xen bootloader may return
  -EAGAIN. This may result in no data read or partial data read.
  With this patch, bootloader will read again when that happens.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14527250] [bug 14268749]  

* Thu Sep 06 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-47 
- qemu: Disable qemu monitor by default.
  Xen Security Advisory XSA-19
  guest administrator can access qemu monitor console
  ISSUE DESCRIPTION
  =================
  A guest administrator who is granted access to the graphical console
  of a Xen guest can access the qemu monitor.  The monitor can be used
  to access host resources.
  IMPACT
  ======
  A malicious guest administrator can access host resources (perhaps
  belonging to other guests or the underlying system) and may be able to
  escalate their privilege to that of the host.
  VULNERABLE SYSTEMS
  ==================
  Installations where guest administrators do not have access to a
  domain's graphical console, or containing only PV domains configured
  without a graphical console, are not vulnerable.
  Installations where all guest administrators are trustworthy are not
  vulnerable, even if the guest operating systems themselves are
  untrusted.
  Systems using xend/xm: At least all versions since Xen 4.0 are
  affected.  Systems are vulnerable even if "monitor=no" is specified in
  the xm domain configuration file - this configuration option is not
  properly honoured in the vulnerable versions.
  Systems using libxl/xl: All versions are affected.  The "monitor="
  option is not understood, and is therefore ignored, by xl.  However,
  systems using the experimental device model version based on upstream
  qemu are NOT vulnerable; that is, Xen 4.2 RC systems with
  device_model_version="qemu_xen" specified in the xl domain config
  file.
  Systems using libvirt are vulnerable.  For "xen:" URIs, see xend/xm,
  above.  For "libxl:" URIs, all versions are affected.
  Systems based on the Xen Cloud Platform are NOT vulnerable.
  CONFIRMING VULNERABILITY
  ========================
  Connect to the guest's VNC (or SDL) graphical display and make sure
  your focus is in that window.  Hold down CTRL and ALT and press 2.
  You will see a black screen showing one of "serial0", "parallel0" or
  "QEMU <version> monitor".  Repeat this exercise for other digits 3 to
  6.  CTRL+ALT+1 is the domain's normal graphical console.  Not all
  numbers will have screens attached, but note that you must release and
  re-press CTRL and ALT each time.
  If one of the accessible screens shows "QEMU <version> monitor" then
  you are vulnerable.  Otherwise you are not.
  MITIGATION
  ==========
  With xl in Xen 4.1 and later, supplying the following config
  option in the VM configuration file will disable the monitor:
  device_model_args=["-monitor","null"]
  With xend the following config option will disable the monitor:
  monitor_path="null"
  Note that with a vulnerable version of the software specifying
  "monitor=0" will NOT disable the monitor.
  We are not currently aware of the availability of mitigation for
  systems using libvirt.
  NOTE REGARDING EMBARGO
  ======================
  This issue was publicly discussed online by its discoverer.
  There is therefore no embargo.
  NOTE REGARDING CVE
  ==================
  This issue was previously reported in a different context, not to Xen
  upstream, and assigned CVE-2007-0998 and fixed in a different way.  We
  have requested a new CVE for XSA-19 but it is not yet available.
  == PATCH ==
  The qemu monitor is an overly
  powerful feature which must be protected from untrusted (guest)
  administrators.
  Neither xl nor xend expect qemu to produce this monitor unless it is
  explicitly requested.
  This is a security problem, XSA-19.  Previously it was CVE-2007-0998
  in Red Hat but we haven't dealt with it in upstream.  We hope to have
  a new CVE for it here but we don't have one yet.
  Signed-off-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Tue Aug 28 2012 Junjie Wei <junjie.wei@oracle.com> - 4.1.2-46 
- VMs with more than 64 VCPUs cannot be saved. This patch fixes the bug by
  extending the VCPU map. (From Keir Fraser <keir.xen@gmail.com>)
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Oracle-bug: 13587669 

* Tue Aug 28 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-45 
- xend: disable SCSI device discover during xend start
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14538564]  

* Thu Aug 23 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-44 
- x86/pvhvm: properly range-check PHYSDEVOP_map_pirq/MAP_PIRQ_TYPE_GSI
  Xen Security Advisory CVE-2012-3498 / XSA-16
  PHYSDEVOP_map_pirq index vulnerability
  ISSUE DESCRIPTION
  =================
  PHYSDEVOP_map_pirq with MAP_PIRQ_TYPE_GSI does not range check
  map->index.
  IMPACT
  ======
  A malicious HVM guest kernel can crash the host.  It might also be
  able to read hypervisor or guest memory.
  VULNERABLE SYSTEMS
  ==================
  All Xen systems running HVM guests.  PV guests are not vulnerable.
  The vulnerability dates back to Xen 4.1.  Xen 4.0 is not vulnerable.
  4.1, the 4.2 RCs, and xen-unstable.hg are vulnerable.
  MITIGATION
  ==========
  This issue can be mitigated by ensuring that the guest kernel is
  trustworthy, or by running only PV guests.
  Patch:
  This is being used as a array index, and hence must be validated before
  use.
  This is XSA-16 / CVE-2012-3498.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Thu Aug 23 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-43 
- console: bounds check whenever changing the cursor due to an escape code
  Xen Security Advisory CVE-2012-3515 / XSA-17
  Qemu VT100 emulation vulnerability
  ISSUE DESCRIPTION
  =================
  The device model used by fully virtualised (HVM) domains, qemu, does
  not properly handle escape VT100 sequences when emulating certain
  devices with a virtual console backend.
  IMPACT
  ======
  An attacker who has sufficient privilege to access a vulnerable device
  within a guest can overwrite portions of the device model's address
  space. This can allow them to escalate their privileges to that of the
  device model process.
  VULNERABLE SYSTEMS
  ==================
  All Xen systems running HVM guests are potentially vulnerable to this
  depending on the specific guest configuration. The default
  configuration is vulnerable.
  Guests using either the traditional "qemu-xen" or upstream qemu device
  models are vulnerable.
  This is XSA-17 / CVE-2012-3515
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Wed Aug 22 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-42 
- xen: Don't BUG_ON() PoD operations on a non-translated guest.
  Xen Security Advisory CVE-2012-3496 / XSA-14
  XENMEM_populate_physmap DoS vulnerability
  ISSUE DESCRIPTION
  =================
  XENMEM_populate_physmap can be called with invalid flags.  By calling
  it with MEMF_populate_on_demand flag set, a BUG can be triggered if a
  translating paging mode is not being used.
  IMPACT
  ======
  A malicious guest kernel can crash the host.
  VULNERABLE SYSTEMS
  ==================
  All Xen systems running PV guests.  Systems running only HVM guests
  are not vulnerable.
  The vulnerability dates back to at least Xen 4.0.  4.0, 4.1, the 4.2
  RCs, and xen-unstable.hg are all vulnerable.
  MITIGATION
  ==========
  This issue can be mitigated by ensuring that the guest kernel is
  trustworthy or by running only HVM guests.
  This is XSA-14 / CVE-2012-3496
  Signed-off-by: Tim Deegan <tim@xen.org>
  Reviewed-by: Ian Campbell <ian.campbell@citrix.com>
  Tested-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Wed Aug 22 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-41 
- xen: handle out-of-pirq condition correctly in PHYSDEVOP_get_free_pirq
  Xen Security Advisory CVE-2012-3495 / XSA-13
  hypercall physdev_get_free_pirq vulnerability
  ISSUE DESCRIPTION
  =================
  PHYSDEVOP_get_free_pirq does not check that its call to get_free_pirq
  succeeded, and if it fails will use the error code as an array index.
  IMPACT
  ======
  A malicious guest might be able to cause the host to crash, leading to
  a DoS, depending on the exact memory layout.  Privilege escalation is
  a theoretical possibility which cannot be ruled out, but is considered
  unlikely.
  VULNERABLE SYSTEMS
  ==================
  All Xen systems.
  Xen 4.1 is vulnerable.  Other versions of Xen are not vulnerable.
  MITIGATION
  ==========
  This issue can be mitigated by ensuring (inside the guest) that the
  kernel is trustworthy and avoiding situations where something might
  repeatedly cause the attempted allocation of a physical irq. XXXX?
  This is XSA-13 / CVE-2012-3495
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Jan Beulich <JBeulich@suse.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Wed Aug 22 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-40 
- xen: prevent a 64 bit guest setting reserved bits in DR7
  XSA-12:   Xen Security Advisory CVE-2012-3494 / XSA-12
  hypercall set_debugreg vulnerability
  ISSUE DESCRIPTION
  =================
  set_debugreg allows writes to reserved bits of the DR7 debug control
  register on x86-64.
  IMPACT
  ======
  A malicious guest can cause the host to crash, leading to a DoS.
  If the vulnerable hypervisor is run on future hardware, the impact of
  the vulnerability might be widened depending on the future assignment
  of the currently-reserved debug register bits.
  VULNERABLE SYSTEMS
  ==================
  All systems running 64-bit paravirtualised guests.
  from the patch file:
  The upper 32 bits of this register are reserved and should be written as
  zero.
  This is XSA-12 / CVE-2012-3494
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Ian Campbell <ian.campbell@citrix.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None]  

* Fri Aug 10 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-39 
- fix xm create vcpu_avail exceeds XMLRPC int limits
  If maxvcpus = vcpus = 40, (1<<40 -1) will exceed XMLRPC int limit. Change it to
  str will work. Then in the xend side, it will converted back to int.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14473041] 

* Wed Aug 08 2012 Junjie Wei <junjie.wei@oracle.com> - 4.1.2-38 
- In bootloader(), domains_lock is first released to avoid a stunk bootloder from
  denying service to the other xend clients. It is re-acquired before returning
  to domain creation to cover the changes to be made. But if something goes wrong
  and domains_lock is not re-acquired, we may hit an error when releasing it one
  more time. This patch makes sure that the released domains_lock is re-acquired
  before returning.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Oracle-bug: 14407719 

* Wed Aug 08 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-37 
- x86-64/MMCFG: correct base address computation for regions not starting at bus 0
  As per the specification, the base address reported by ACPI is the one
  that would be used if the region started at bus 0. Hence the
  start_bus_number offset needs to be added not only to the virtual
  address, but also the physical one when establishing the mapping, and
  it then needs to be subtracted when obtaining the virtual address for
  doing accesses.
  Signed-off-by: Jan Beulich <jbeulich@novell.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Oracle-Bugzilla: 13674 [bug None] 

* Wed Aug 08 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-36 
- Revert partially "x86/cpuidle: do not flush cache unless entering C3" (r3399)
  I had two patches in my tree when committing the above mentioned
  patch. So the c3399 ended up having parts of another patch. Backing
  that out.
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug None] 

* Wed Aug 08 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-35 
- x86/cpuidle: do not flush cache unless entering C3
  Nor is there a need to disable bus master arbitration in that case.
  Signed-off-by: Wei Wang <wei.wang2@amd.com>
  Modified-by: Zhang, Yang Z <yang.z.zhang@intel.com>
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Committed-by: Jan Beulich <jbeulich@suse.com>
  [and in OVS]:
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  xen-unstable changeset:   25195:a06e6cdeafe3
  xen-unstable date:        Mon Apr 16 13:05:28 2012 +0200
  Fedora Bug: 841330 [bug None] 

* Wed Aug 01 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-34 
- Xen Security Advisory CVE-2012-3433 / XSA-11
  HVM guest destroy p2m teardown host DoS vulnerability
  An HVM guest is able to manipulate its physical address space such
  that tearing down the guest takes an extended period amount of
  time searching for shared pages.
  This causes the domain 0 VCPU which tears down the domain to be
  blocked in the destroy hypercall. This causes that domain 0 VCPU to
  become unavailable and may cause the domain 0 kernel to panic.
  There is no requirement for memory sharing to be in use.
  From the patch description:
  xen: only check for shared pages while any exist on teardown
  Avoids worst case behavour when guest has a large p2m.
  This is XSA-11 / CVE-2012-nnn
  Signed-off-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Tested-by: Olaf Hering <olaf@aepfle.de>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> 

* Mon Jul 30 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-33 
- x86: fix off-by-one in nr_irqs_gsi calculation
  Upstream change: 25688:e6266fc76d08
  highest_gsi() returns the last valid GSI, not a count.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Joe Jin <joe.jin@oracle.com>
  Acked-by: Keir Fraser <keir@xen.org>
  Acked-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14137461] 

* Thu Jul 26 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-32 
- Xen Security Advisory XSA-10
  HVM guest user mode MMIO emulation DoS vulnerability
  ISSUE DESCRIPTION
  =================
  Internal data of the emulator for MMIO operations may, under
  certain rare conditions, at the end of one emulation cycle be left
  in a state affecting a subsequent emulation such that this second
  emulation would fail, causing an exception to be reported to the
  guest kernel where none is expected.
  NOTE: No CVE number!
  The patch description is as follow:
  x86/hvm: don't leave emulator in inconsistent state
  The fact that handle_mmio(), and thus the instruction emulator, is
  being run through twice for emulations that require involvement of the
  device model, allows for the second run to see a different guest state
  than the first one. Since only the MMIO-specific emulation routines
  update the vCPU's io_state, if they get invoked on the second pass,
  internal state (and particularly this variable) can be left in a state
  making successful emulation of a subsequent MMIO operation impossible.
  Consequently, whenever the emulator invocation returns without
  requesting a retry of the guest instruction, reset io_state.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Keir Fraser <keir@xen.org>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> 

* Fri Jul 20 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-31 
- pygrub: log to syslog
  pygrub: add syslog support to pygrub
  Currently, when pygrub failed, we don't know the reason because xend/xl will
  not capture the stderr message.
  This patch will log the error message to syslog.
  We choosing syslog because pygrub could be called concurrently. If we want
  dedicated log file for pygrub, we need a log server. Using syslog is simple.
  Example /var/log/messages log:
  Jul 19 11:59:53 ovs030 [2012-07-19 11:59:53,504 7112] ERROR (pygrub:848) [Errno 95] Operation not supported Traceback (most recent call last):   File "/share/repos/xen-unstable/tools/pygrub/src/pygrub", line 828, in ?     fs = fsimage.open(file, offset, bootfsoptions) IOError: [Errno 95] Operation not supported
  Jul 19 11:59:53 ovs030 [2012-07-19 11:59:53,508 7112] ERROR (pygrub:892) Unable to find partition containing kernel
  '7112' is the pygrub PID, so we can distinguish each process.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14268749] 

* Fri Jul 20 2012 Dave McCracken <dave.mccracken@oracle.com> - 4.1.2-30 
- Add restore (and migrate) functionality back in for PV superpage-enabled guests.
  Signed-off-by: Dave McCracken <dave.mccracken@oracle.com>
  Acked-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 14005957] 

* Fri Jul 20 2012 Dave McCracken <dave.mccracken@oracle.com> - 4.1.2-29 
- Add "allowhugepage" flag as a synonym for "allowsuperpage"
  for compatibility with previous releases.
  Signed-off-by: Dave McCracken <dave.mccracken@oracle.com>
  Acked-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Patch_name: ovs-xen-4.1-fspage-1.patch [bug 13821795] 

* Thu Jul 19 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-28 
- add more logs for bootloader diagnostic
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14325570&14268749] 

* Wed Jun 27 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-27 
- fix bootloader hang/crash xend on wrong bootargs.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Steve Prochniak <steve.prochniak@oracle.com> [bug 14195864] 

* Tue Jun 26 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-26 
- gnttab: don't use domain lock for serialization
  Instead use the affected domain's grant table lock, at once reducing
  the scopes during which locks are being held and hence allowing
  significantly better parallelism.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Tested-by: Andrew Thomas <andrew.thomas@oracle.com>
  [This is backport of cs 25419]
  Committed-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> 

* Tue Jun 19 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-25 
- fix hotplug script locking using flock
  We already has a fix there, but this one is better:
  1. No timeout: in the old one, if one process holding the lock more than 100
  seconds, other processes could steal it.
  2. No leftovers: if a process holding this lock is dead, it will close the lock
  file, so it will not affect other processes.
  This patch is from OL5U8 Red Hat xen.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 13979094] 

* Tue Jun 12 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-24 
- Xen Security Advisory CVE-2012-2934 / XSA-9
  *** EMBARGOED UNTIL Tuesday 2012-06-12 12:00:00 UTC *** 

* Mon Jun 11 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-23 
- tools/hotplug: fix locking
  The current locking implementation would allow two processes get the lock
  simultaneously:
  ++ echo 16741: /etc/xen/scripts/block
  ++ cut -d : -f 1
  + local pid=16741
  + '[' -n 16741 -a 16741 '!=' unknown -a '!' -f /proc/16741/status ']'
  + '[' 5 -gt 5 ']'
  + sleep 0
  + retries=6
  + '[' 6 -lt 100 ']'
  + mkdir /var/run/xen-hotplug/block
  ++ _lock_owner /var/run/xen-hotplug/block
  ++ cat /var/run/xen-hotplug/block/owner
  + local 'new_owner=16741: /etc/xen/scripts/block'
  + '[' '16741: /etc/xen/scripts/block' '!=' '16741: /etc/xen/scripts/block' ']'
  ++ echo 16741: /etc/xen/scripts/block
  ++ cut -d : -f 1
  + local pid=16741
  + '[' -n 16741 -a 16741 '!=' unknown -a '!' -f /proc/16741/status ']'
  + '[' 6 -gt 5 ']'
  + sleep 1
  + do_or_die losetup -r /dev/loop27 /OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb00001200002b0ef651033c8381.img
  + losetup -r /dev/loop27 /OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb00001200002b0ef651033c8381.img
  + do_or_die losetup -r /dev/loop27 /OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb0000120000143173990458f2a7.img
  + losetup -r /dev/loop27 /OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb0000120000143173990458f2a7.img
  + xenstore_write backend/vbd/33/51920/node /dev/loop27
  + _xenstore_write backend/vbd/33/51920/node /dev/loop27
  + log debug 'Writing backend/vbd/33/51920/node' '/dev/loop27 to xenstore.'
  + local level=debug
  + shift
  + logger -p daemon.debug -- /etc/xen/scripts/block: 'Writing backend/vbd/33/51920/node' '/dev/loop27 to xenstore.'
  ioctl: LOOP_SET_FD: Device or resource busy
  + xenstore-write backend/vbd/33/51920/node /dev/loop27
  + fatal losetup -r /dev/loop27 '/OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb0000120000143173990458f2a7.img failed'
  This patch removes the ownner support and fixed this issue per my test.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 13979094] 

* Thu Jun 07 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-22 
- block: use -b instead of -a for file exist testing
  it will be interpreted as: expr1 -a expr2
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com> 

* Mon Jun 04 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-21 
- remove unecessary balloon retries on vm create
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 14143327] 

* Mon May 07 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-20 
- get host uuid from sysfs
  Expose host uuid works on 3.0.3, but not 3.1.1:
  # /usr/bin/hal-get-property  --udi /org/freedesktop/Hal/devices/computer --key system.hardware.uuid
  error: libhal_device_get_property_type: org.freedesktop.Hal.NoSuchProperty: No
  property system.hardware.uuid on device with id /org/freedesktop/Hal/devices/computer
  hal-get-peroperty doesn't work with UEK2.
  This patch will get host uuid from sysfs, it works on 3.0.3+.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Fri Apr 20 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-19 
- Xen Security Advisory 8 v2 - guest DoS on syscall/sysenter exception
  *** EMBARGOED UNTIL Tuesday 2012-05-01 12:00:00 UTC *** 

* Thu Mar 29 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-18 
- his patch will create a loop device node if it is not exist when VM start.
  After this patch, Kernel max_loop could be 8.
  I tested it could create 1025 loop device nodes within 1 minutes.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Mon Mar 26 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-17 
- Set max cstate to 1.
  We have several bugs that cstate made system unstable, both for ovm2 and ovm3:
  For OVM3.x:
  Bug 13703504 - unexplained network disconnect causes ocfs to fence the server
  https://forums.oracle.com/forums/thread.jspa?threadID=2347014&tstart=0
  For OVM2.x
  https://bug.oraclecorp.com/pls/bug/webbug_edit.edit_info_top?rptno=10631565
  https://bug.oraclecorp.com/pls/bug/webbug_edit.edit_info_top?rptno=13494054 [bug 13703504] 

* Mon Mar 26 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-16 
- revert xen unstable changeset 22315: it breaks SSL live migration.
  Original change set:
  # HG changeset patch
  # User Miroslav Rezanina <mrezanin@redhat.com>
  # Date 1288262432 -3600
  # Node ID 31b8844fab99e0e3358e983b9a7b6617148045b3
  # Parent  28a16074681582f1209c9077f870ccf44927133e
  Do not wait for memory teardown when live migrate
  When trying to live migrate guest with great memory (e.g. 20 GB),
  there's delay caused by destroying source copy of domain.  To speed up
  this process we can close socket before starting guest destroy, as
  source guest is not running anymore.
  Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
  Signed-off-by: Ian Jackson <ian.jackson@eu.citrix.com> [bug 13808326&13874471] 

* Sat Mar 24 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-15 
- Backport of c/s 24013 of the 32-bit compat layer, which states: "
  pvhvm running with more than 32 vcpus and pv_irq/pv_time enabled
  need vcpu placement to work, or else it will softlockup.
  Signed-off-by: Zhenzhong Duan <zhenzhong.duan@oracle.com>
  Committed-by: Keir Fraser <keir@xen.org>
  "
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 13073337] 

* Sat Mar 24 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-14 
- Backport of c/s 24013, which states: "
  pvhvm running with more than 32 vcpus and pv_irq/pv_time enabled
  need vcpu placement to work, or else it will softlockup.
  Signed-off-by: Zhenzhong Duan <zhenzhong.duan@oracle.com>
  Committed-by: Keir Fraser <keir@xen.org>
  "
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 13073337] 

* Wed Mar 21 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-13 
- From Message-ID: <1332267691-13179-1-git-send-email-david.vrabel@citrix.com>
  If a maximum reservation for dom0 is not explictly given (i.e., no
  dom0_mem=max:MMM command line option), then set the maximum
  reservation to the initial number of pages.  This is what most people
  seem to expect when they specify dom0_mem=512M (i.e., exactly 512 MB
  and no more).
  This change means that with Linux 3.0.5 and later kernels,
  dom0_mem=512M has the same result as older, 'classic Xen' kernels. The
  older kernels used the initial number of pages to set the maximum
  number of pages and did not query the hypervisor for the maximum
  reservation.
  It is still possible to have a larger reservation by explicitly
  specifying dom0_mem=max:MMM.
  Signed-off-by: David Vrabel <david.vrabel@citrix.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  NOTE: This behaviour should also be implemented in the Linux kernel. [bug 13860516] 

* Wed Mar 14 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-12 
- Correct stop xend return status [bug 13845552] 

* Tue Mar 13 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-11 
- We don't support PCI segmented domains yet, so for right now
  just ignore the hypercall with that type. Dom0 is smart enough
  to fallback to the old type. If need to back-port the support
  then revisit:
  23855:e2bd50b0843a
  user:        Jan Beulich <jbeulich@suse.com>
  date:        Sun Sep 18 00:12:19 2011 +0100
  summary:     PCI multi-seg: add new physdevop-s
  changeset:   23854:e5263921c85e
  user:        Jan Beulich <jbeulich@suse.com>
  date:        Sun Sep 18 00:10:03 2011 +0100
  summary:     PCI multi-seg: introduce notion of PCI segments
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 13727499] 

* Tue Mar 13 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-10 
- If bridge MTU != 1500, then set tap MTU to bridge MTU [bug 13773039] 

* Thu Mar 08 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-9 
- Version numbering, CVE-2012-0029 and upstream fixes
  Xen: 23263:b01091775dd9
  qemu: 3cf61880 

* Wed Feb 29 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-8 
- If needed; Change the VIF MTU before connecting it to the bridge. [bug 13773039] 

* Mon Feb 27 2012 Annie Li <annie.li@oracle.com> - 4.1.2-7 
- Fix bug 12861822(VM fails to resume automatically in WHQL test) 

* Mon Feb 27 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-6 
- Put back the patch that prevent older guest that uses kudzu from hanging
  on a reboot. Fixed the patch to prevent excessive watcher writes which
  causes xend, xenstored to run at a 100%  cpu usage. Now the watch is written
  only if console in Initialising, InitWait, Initialised states which happen
  once at boot time. [bug 13523487] 

* Thu Feb 23 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-5 
- The ACPI compiler/dsdt.asl table generates nodes for S3/S4 which are
  now 12 bytes (rather than 14). Update the sizes of the chunks to be excised.
  Fixes windows boot/install and linux shutdown issues. [bug 13772650] 

* Wed Feb 22 2012 Kurt Hackel <kurt.hackel@oracle.com> - 4.1.2-4 
- set max_phys_cpus=160 [bug 13727780]

* Mon Feb 20 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-3 
- PLE can cause problems
  With PLE enabled, 2.6.32 guests will crash early on with:
  ..MP-BIOS bug: 8254 timer not connected to IO-APIC
  # a few lines omitted..
  Kernel panic - not syncing: IO-APIC + timer doesn't work!  Boot with apic=debug
  The patch to vpt.c is the suggested fix from: xiantao.zhang@intel.com.
  patch to vmcs.c was the prioir workaround. 

* Mon Feb 20 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-2 
- Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Gary Grebus <gary.grebus@oracle.com> 

* Mon Dec 19 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-1
- rebase patches to 4.1.2 tree
  remove dm-nfs
  update insmod
  disable PLE temporarily
  stop building/install documentation - it can't be read on OVM server.

* Thu Sep 22 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-81 
- re-enable dm-nfs support.
  Signed-off-by: Andrew Thomas <andrew.thomas@oracle.com>
  Signed-off-by: kurt.hackel@oracle.com
  Approved-by: steve.noyes@oracle.com 

* Tue Sep 06 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-80 
- Make performance the default governor like we did for 2.2.X series.
  Signed-off-by: Andrew Thomas <andrew.thomas@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Fri Jul 15 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-79 
- KDB: enhance dgdt. hvm set single_step. gdbsx, add trace print. 

* Fri Jul 08 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-78 
- fix solaris domU detection
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> [bug 12718579] 

* Thu Jul 07 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-77 
- tools/pygrub: fix solaris kernel sniff
  Solaris 11 build 163+ removes '/platform/i86xpv/kernel/unix' and only the
  64-bit PV kernel file '/platform/i86xpv/kernel/amd64/unix' exists.
  This patch fixes the detection.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 12718579] 

* Thu Jul 07 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-76 
- tools/hotplug/Linux/block: fix shared loop device detection
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 12316734] 

* Thu Jun 16 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-75 
- AMD Bulldozer cpu's require some fixes to get them working.
  We do NOT provide the support for these features:
  - SVM perfmance enhancements ("clean bits").
  - AVX
  - LWP
  We expect Xen to be started with xsave=0 for AMD bulldozer systems in order
  to disable AVX.
  Xen-4.1-testing: 22462:98eb4a334b77
  Xen-4.1-testing: 23027:2dde81ed2e3d
  xen-unstable.hg: 23290:1ac7336b6298
  xen-unstable.hg: 23511:450f1d198e1e
  Signed-off-by: Andrew Thomas <andrew.thomas@oracle.com> 

* Thu Jun 16 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-74 
- This is a Xen cumulative patch from c/s 21458 to 21511 (in the 4.0
  testing tree.) It includes an important VT-d related CVE and necessary
  updates for AMD (Bulldozer in particular).
  Signed-off-by: Andrew Thomas <andrew.thomas@oracle.com> 

* Thu Jun 09 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-73 
- fix xendomains to shutdown vms on stop
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 11907918] 

* Thu Jun 09 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-72 
- make non-ssl vnc listen on localhost only.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Wed Jun 08 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-71 
- KDB: Handle support for MTF flag for hvm guest single step. Set single_step in
  case of HVM guest so that MTF flag is set. 

* Mon May 23 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-70 
- enable domain lock callout.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com> 

* Mon May 23 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-69 
- fix to avoid ballooning when dom0-min-mem is set and enable-dom0-ballooning
  is enabled. [bug 12404026] 

* Wed May 11 2011 Junjie Wei <junjie.wei@oracle.com> - 4.0.0-68 
- Changes to parameters passed to ovs-agent-dlm.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Wed May 11 2011 Junjie Wei <junjie.wei@oracle.com> - 4.0.0-67 
- Revert to r2515. 

* Wed May 11 2011 Junjie Wei <junjie.wei@oracle.com> - 4.0.0-66 
- Change parameters passed to ovs-agent-dlm.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Wed Apr 27 2011 Annie Li <annie.li@oracle.com> - 4.0.0-65 
- Fix Bug 10238928 - XEND CONFIG LAYER FAILS TO REFRESH GUEST DEVICE INFO WHEN CHANGED DYNAMICALLY.
  1. Add deleteDevice in XendDomainInfo.py.
  2. Call deleteDevice in deviceDestroyCallback of DevController.py.
  3. set event after wait timeout. 

* Thu Mar 24 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-64 
- KDB: print longs for page struct fields. 

* Fri Mar 18 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-63 
- Add -OVM to version information. This is visible through smbios/dmidecode
  information for HVM (ie Solaris) guests. [bug 11792774] 

* Fri Mar 18 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-62 
- Important security fix.
  # HG changeset patch
  # User Tim Deegan <Tim.Deegan@citrix.com>
  # Date 1300122058 0
  # Node ID ee088a0b5cb89793da67abb3cc389f42247bba98
  # Parent  b024d5ecc1943c0d74bfc04cb440ea96159e429b
  x86_64: fix error checking in arch_set_info_guest()
  Cannot specify user mode execution without specifying user-mode
  pagetables.
  Signed-off-by: Tim Deegan <Tim.Deegan@citrix.com>
  Acked-by: Keir Fraser <keir@xen.org>
  xen-unstable changeset:   23034:c79aae866ad8
  xen-unstable date:        Mon Mar 14 16:59:49 2011 +0000 

* Fri Mar 18 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-61 
- Cumulative updates from upstream (mostly HVM related).
  Changesets 21423-21457 [inclusive, but removing mercurial repo changes.]
  Includes 21440 which addresses Orabug: 10255006 [bug 10255006] 

* Fri Mar 04 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-60 
- xmstat: fix type in README. 

* Tue Feb 22 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-59 
- KDB: clear watchpoints on all cpus. 

* Mon Feb 21 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.0.0-58 
- When a VIF connect to a bridge change its MTU (1500 | 9000) if needed. 

* Fri Feb 18 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-57 
- KDB: Do detailed display of VMCS on Intel upon dvmc cmd. 

* Fri Feb 18 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-56 
- KDB: enhance dgdt again. check for valid mfn in m2p command. 

* Thu Feb 10 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-55 
- A hack to disable dm-nfs support prioir to Junjie's clean up.
  Signed-off-by: kurt.hackel@oracle.com :-) 

* Thu Feb 03 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-54 
- KDB: refresh disassembler library, udis, to 1.7. 

* Thu Feb 03 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-53 
- KDB: changes related to refreshing upstream ext tree to latest unstable" 

* Mon Jan 31 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-52 
- Import 2.2 patch for Solaris PXE boot. Also update eb-roms.h file to
  prebuilt version (a minor annoyance with srpm repos). [bug 11076422&10135669] 

* Tue Jan 25 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-51 
- gdbsx: update README. kdb: update README with btp cmd. xmstat: Update tools/Makefile and add perf/Makefile to always build and install it. 

* Fri Jan 21 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-50 
- KDB: add new cmd btp, to trace upon breakpoints. Add display of timer structs
  and vlapic structs. 

* Thu Jan 20 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-49 
- XMSTAT: initial checkin. 

* Tue Jan 04 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-48
- Cumulative patch from 21327 to 21422; as we already had some of these
  applied, this cumulative patch omits: 21336, 21337, 21344.
  This patch contains some minor changes for IDLE_DOMAIN_ID to
  DOMID_IDLE changes affecting:
  kdb_cmds.c
  x86/udis86-1.6/kdb_dis.c 

* Mon Dec 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-47 
- Fix xend service stop status: return 0 on success.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Acked-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 10334816] 

* Tue Nov 16 2010 Kevin Lyons <kevin.x.lyons@oracle.com> - 4.0.0-46 
- Add dependency on pciutils-devel for xen-tools package

* Tue Nov 16 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-45 
- KDB: Redo gdt display command. Add commands to display MSRs and cpuid outputs. 

* Thu Oct 07 2010 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-44
- Remove SDL-devel, gtk2-devel, and libX11-devel from BuildRequires

* Wed Oct 06 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.0.0-43 
- Fix a descriptor leak in xenstore. The function xs_daemon_close() was not closing descriptors.
  orabug:10155532 

* Tue Oct 05 2010 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-42 
- Add rule to create /dev/xen/gntdev 

* Tue Oct 05 2010 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-41 
- Disable ballooning of dom0 - this is from 2.2.1 (see bug 8604766
  and 9485681). Not an orabug on this release though. 

* Tue Oct 05 2010 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-40 
- 2.6.32 kernel uses gntdev as a module, so load it at runtime 

* Fri Sep 10 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-39 
- x2apic related fixes from Yinghai Lu. Increase MAX_LOCAL_APIC to 512, change apic_id to u32, etc... 

* Tue Sep 07 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-38 
- Disable intel xsave. Changeset 21336 in unstable. See http://www.gossamer-threads.com/lists/xen/devel/184099, or search xen devel archives for "xen trouble while guest excute float app". 

* Tue Sep 07 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-37 
- gdbsx: Try the MTF flag first during HVM guest single step, reverting to
  manually setting the TF flag if that fails. 

* Thu Sep 02 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-36 
- Apply patches from Yinghai: mparse_pass_32bit_apicid, 256_cpus, x2apic_preenable, x2apic-acpi, and remove_warning.patch. 

* Sun Aug 29 2010 Kevin Lyons <kevin.x.lyons@oracle.com> - 4.0.0-35 
- Stage qemu-dm in /usr/lib64 

* Thu Aug 26 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-34 
- Refresh xen to xen RELEASE-4.0.1, C/S 21326. Refresh QEMU to TAG xen-4.0.1. 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-33 
- xend: acpi s3/s4 code clean up. 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-32 
- Backport xen unstable cs 21839:
  hvmloader: clear the whole shared-info page when shutting down xenbus
  since the contents might be in the wrong word-size for later users.
  Signed-off-by: Tim Deegan <Tim.Deegan@citrix.com> 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-31 
- xend: add acpi s3/s4 configuration options. 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-30 
- hvmloader: enable dynamic acpi s3/s4 change. 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-29 
- Backport xen-unstable-cs-21831:
  hvmloader: clear the xenbus event-channel when we're done with it.
  Otherwise a later xenbus client that naively waits for the rising edge
  could get stuck.
  Signed-off-by: Tim Deegan <Tim.Deegan@citrix.com> 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-28 
- Backport xen-unstable-cs-21767:
  hvmloader: Add a xenbus frontend so it can read values from xenstore
  Signed-off-by: Tim Deegan <Tim.Deegan@citrix.com> 

* Fri Jul 16 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-27 
- display more cpu data info. sync with ext tree c/s 20376, unst c/s 21811. 

* Thu Jul 15 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-26 
- Make gdbsx part of normal xen to align with upstream. 

* Thu Jul 15 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-25 
- Remove space from qThreadInfo packet because newer gdb version 7* has
  a bug in parsing thread list. Also, another gdb bug in printf. 

* Fri Jul 09 2010 Srinivas Maturi <srinivas.maturi@oracle.com> - 4.0.0-24 
- Stage hvmloader and qemu-dm in /usr/lib and /usr/lib64 for backward
  compatibility with vm.cfg files from OVM 2.x [bug 9348075] 

* Thu Jul 08 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-23 
- back port xen-unstable change set 21684:
  tools/python: sxp parser: show empty string
  This patch makes the sxp parser show empty string.
  Test case:
  import sxp
  sxp.show(sxp.from_string('(a "")'))
  sxp.show(sxp.from_string("(a '')"))
  Without this patch:
  (a )(a )
  With this patch:
  (a '')(a '')
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Thu Jul 08 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-22 
- Improve xend service to give better status report. [bug 9882998] 

* Tue Jun 29 2010 Dan Magenheimer <dan.magenheimer@oracle.com> - 4.0.0-21 
- tmem page dedup and tmem bug fixes through xen-unstable cs21658 

* Fri Jun 25 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-20 
- Add ext4 support for pygrub: use the shipped ext2 library. 

* Fri Jun 18 2010 Kevin Lyons <kevin.x.lyons@oracle.com> - 4.0.0-19 
- Alter xen/Makefile to install the debug hypervisor when built with the gdbsx flag.
  Oracle-bug:9817500 

* Wed Jun 09 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-18 
- KDB: Add new cmd to display loaded modules in a guest. Add barrier() in
  kdb_trap_immed(). 

* Tue May 25 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-17 
- 1) NEW: conditional breakpoints.  2) Redo dirq cmd.  3) NEW: cmd dvit (display per cpu vector irq table).

* Mon May 17 2010 Gary Grebus <gary.grebus@oracle.com> - 4.0.0-16 
- Add workarounds for timer interrupt routing crashes on some Supermicro systems.
  The MP BIOS tables on some systems incorrectly route the timer interrupt.
  Try to automatically set the kernel parameter "acpi_skip_timer_override" on
  these systems.  Add kernel parameter "acpi_use_timer_override" to disable
  automatic application.
  Signed-off-by: kurt.hackel@oracle.com [bug 9694370] 

* Sun May 16 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-15 
- expose host uuid to guest via xenstore.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Wed May 12 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-14 
- Set VM vnc server listen everywhere.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Wed May 12 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-13 
- Enables xend ssl relocation server.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Sun May 09 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-12 
- Enable dm-nfs block setup.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Gary Grebus <gary.grebus@oracle.com> 

* Wed May 05 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-11 
- disable network-script 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-10 
- Load backend modules at xend start. 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-9 
- Put xenstored tdb to tmpfs. 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-8 
- Add long cmdline support. 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-7 
- Add domain running lock callout hook. 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-6 
- Add vbd/vif qos support. 

* Fri Apr 02 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-5 
- Enable building of debug pkgs.

* Fri Apr 02 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-4 
- DEBUG PKG: Enable build of gdbsx so it can be included in our debug pkg. 

* Fri Apr 02 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-3 
- KDB: merge kdb patch. 

* Wed Apr 01 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-2
- Add dummy-null.patch so the autopatch can be turned on. The autopatch will
  fail if there are no patches in the spec file.

* Wed Apr 01 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-1
- Initial spec file for xen 4.0 in ovm3.0 release. The initial tar file 
  for Source0 is tar of the base expanded tree. Basically, xen 4.0 c/s 21088
  with qemu copied locally, and iasl compiled and put in the acpi directory.
  
